﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;  // needed for class Image


namespace Zikaron
{
    public partial class Form3 : Form
    {
        Button btn1, btn2;
        int mone = 0;  // מונה למספר הזגות שנחשפו
        int count = 4; // מספר זוגות הקלפים במשחק
        int move = 0; // מונה למספר המהלכים במשחק

        Button[] buttons ;
        PictureBox[] PictureBoxs;
        Image[] images;

        public Form3()
        {
            InitializeComponent();
        }

         static Random rnd = new Random(); // העצם חייב להיות סטטי ו...מחוץ לפעולה
         private int free(PictureBox[] pictureBoxs)
         {

             int x = rnd.Next(count * 2);  // שלנו PictureBox-נגריל מספר בטווח של כמות ה  
             while ((pictureBoxs[x].Image != null)) // כל עוד המקום שהגרלנו לא פנוי
                 x = rnd.Next(count * 2);  // נגריל מיקום אחר בטווח

             return x; //  נחזיר את המיקום הפנוי שנמצא
         }

         private void Button2_Click(object sender, EventArgs e)
         {
             // count = int.Parse (TextBox1.Text);
             count = (int)numericUpDown1.Value;

             buttons = new Button[count * 2];
             PictureBoxs = new PictureBox[count * 2];
             images = new Image[count];


             // Create buttons & pictureBox
             int inx = 0;  // מונה למספר הקלפים שנוצרו

             int c = ColsNum();       // מספר עמודות 
             int r = (count * 2) / c; // מספר שורות

             int x, y;
             for (int row = 0; row < r; row++)
             {
                 for (int col = 0; col < c; col++)
                 {
                     x = 33 + (122 * col);
                     y = 77 + (110 * row);
                     // Create(inx, x, y);
                     Create(inx, new System.Drawing.Point(x, y));
                     inx = inx + 1;  // קידום מספר הקלף
                 }
             }

             //this.Size.Width = 33 * 2 + (122 * c);
             //this.Size.Height = 77 + 27 + (110 * r);
             this.Size = new Size(33 * 2 + (122 * c), 77 * 2 + (110 * r));


             // get images and fill it + set Tag
             for (int i = 0; i < images.Length; i++) // עבור כל תמונה אפשרית
             {
                 // נקבל את מיקום התמונה מהמשתמש
                 OpenFileDialog1.ShowDialog();
                 images[i] = Image.FromFile(OpenFileDialog1.FileName);

                 for (int j = 0; j < 2; j++)  // נבצע פעמיים עבור זוג המיקומים לאותה תמונה
                 {
                     x = free(PictureBoxs);  // פנוי PictureBox  מצא 
                     PictureBoxs[x].Image = images[i]; // מהמערך Image-שים בו את ה  
                     buttons[x].Tag = i; // של הכפתור המתאים Tag במאפיין  Image-שמור את מספר ה 
                 }
             }

         }

        // פעולה לחישוב מספר העמודות האידיאלי
        private int ColsNum() 
        {
            int c  = (int) Math.Sqrt(count * 2);
            int r  = (count * 2) / c;
            while  (r * c != count * 2)  // חיפוש מס שורות + עמודות שיתחלקו בדיוק
            {
                c = c + 1;
                r = (count * 2) / c;
            }
            return c;   
        }

        // פעולה ליצירת "קלף" במשחק  
        // שנוצר אוטומטית Designer.cs הקוד מועתק "עקרונית" מהקובץ 
        // private void Create(int inx , int x, int y )
        private void Create(int inx , Point pos )
        {
            PictureBoxs[inx] = new System.Windows.Forms.PictureBox();
            //
            //PictureBox1
            //
           //PictureBoxs[inx].Location = new System.Drawing.Point(x, y);
            PictureBoxs[inx].Location = pos;
            PictureBoxs[inx].Name = "PictureBox";
            PictureBoxs[inx].Size = new System.Drawing.Size(102, 98);
            PictureBoxs[inx].SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
            PictureBoxs[inx].TabIndex = 0;
            PictureBoxs[inx].TabStop = false;

            buttons[inx] = new System.Windows.Forms.Button();
            //
            //Button1
            //
            //buttons[inx].Location = new System.Drawing.Point(x, y);
            buttons[inx].Location = pos;
            buttons[inx].Name = "Button";
            buttons[inx].Size = new System.Drawing.Size(103, 97);
            buttons[inx].TabIndex = 8;
            buttons[inx].UseVisualStyleBackColor = true;

            buttons[inx].Click += new System.EventHandler(this.Button_Click);

            this.Controls.Add(buttons[inx]);
            this.Controls.Add(PictureBoxs[inx]);
        }

        private void Button_Click(object sender, EventArgs e)
        {
            Button btn = (Button)sender;
            move++;

            btn.Visible = false; // לחשוף את הקלף שנלחץ
            if (btn1 == null) // האם זהו הקלף הראשון
            {
                btn1 = btn;        // לשמור את הקלף הראשון
            }
            else
            {
                if (btn2 == null)  // האם זהו הקלף השני
                {
                    btn2 = btn; // לשמור את הקלף השני
                    if (count == mone + 1)  // ?? האם המשחק הסתיים
                    {
                        MessageBox.Show("כל הכבוד, ניצחת ב " + move + " מהלכים !!!");
                    }
                }
                else
                {
                   //  if ((int)btn1.Tag == (int)btn2.Tag) // ... אם נחשפו זוג קלפים 
                       if (btn1.Tag.Equals(btn2.Tag))     // ... אם נחשפו זוג קלפים                    
                    {
                        mone = mone + 1;
                    }
                    else  // הסתר את זוג הקלפים שנחשפו
                    {
                        btn1.Visible = true;  
                        btn2.Visible = true;
                    }

                    btn1 = btn; // שמור את הקלף שנלחץ כקלף ראשון
                    btn2 = null;  // אין לנו עדיין קלף שני
                }
            }

        }

              
    }
}
